/*
    O摜ϊ@ 1.00

   2003/ 5/18 ˁ@P
*/
// Pixels.cpp : CPixels ̎
#include "stdafx.h"
#include "Pixels.h"
#include <comdef.h>

/* ǂݍ */
STDMETHODIMP CPixels::load(BSTR bstrFileName)
{

	_bstr_t bstrName(bstrFileName);

	m_imgImage.Load(bstrName);

	return S_OK;
}

/* ۑ */
STDMETHODIMP CPixels::save(BSTR bstrFileName)
{

	if (m_imgImage.IsNull()) {
		return S_FALSE;
	}

	_bstr_t bstrName(bstrFileName);

	m_imgImage.Save(bstrName);

	return S_OK;

}

/* TCYύX */
STDMETHODIMP CPixels::resize(LONG iWidth, LONG iHeight)
{

	if (m_imgImage.IsNull()) {
		return S_FALSE;
	}

	if (iWidth * iHeight <1) {
		return S_FALSE;
	}

	CImage imgTmp;

	/* wTCYŉC[W쐬 */
	if (imgTmp.Create(iWidth, iHeight, 24, 0) == 0) {
		return S_FALSE;
	}

	/* C[WDC擾 */
	HDC hdcTmp = imgTmp.GetDC();

	/* C[WDC̏kg僂[hݒ */
	SetStretchBltMode(hdcTmp, HALFTONE);

	/* C[WɎwTCYŉ摜` */
	m_imgImage.StretchBlt(hdcTmp, 0, 0, iWidth, iHeight);

	imgTmp.ReleaseDC();

	/* ݂̃C[Wj */
	m_imgImage.Destroy();

	/* wTCYŉ摜𐶐Ȃ */
	if (m_imgImage.Create(iWidth, iHeight, 24, 0) == 0) {
		return S_FALSE;
	}

	/* C[W̉摜` */
	imgTmp.BitBlt(m_imgImage.GetDC(), 0, 0);
	
	m_imgImage.ReleaseDC();
	imgTmp.Destroy();

	return S_OK;

}

/*  */
STDMETHODIMP CPixels::monochrome(void)
{

	if (m_imgImage.IsNull()) {
		return S_FALSE;
	}

	int iWidth = m_imgImage.GetWidth(), iHeight = m_imgImage.GetHeight();
	int iR, iG, iB, iY;

	/* 摜̊esNZ𔒍 */
	for (int i = 0;i < iHeight;i++) {
		for (int j = 0;j < iWidth;j++) {

			iR = (m_imgImage.GetPixel(j, i) & 0x00ff0000) >> 16;
			iG = (m_imgImage.GetPixel(j, i) & 0x0000ff00) >> 8;
			iB = m_imgImage.GetPixel(j, i) & 0x000000ff;

			/* sNZ̖xvZ */
			iY = (int)(0.299 * iR + 0.587 * iG + 0.114 * iB);

			if (iY > 255) {
				iY = 255;
			}

			/* RGB𖾓xœꂵĔ */
			m_imgImage.SetPixelRGB(j, i, iY, iY, iY);

		}
	}

	return S_OK;

}

STDMETHODIMP CPixels::get_Width(LONG* pVal)
{
	if (m_imgImage.IsNull()) {

		*pVal = 0;

		return S_FALSE;

	}

	*pVal = m_imgImage.GetWidth();

	return S_OK;
}

STDMETHODIMP CPixels::get_Height(LONG* pVal)
{

	if (m_imgImage.IsNull()) {

		*pVal = 0;

		return S_FALSE;

	}

	*pVal = m_imgImage.GetHeight();

	return S_OK;
}
